---
title: URLSearchParams.set()
slug: Web/API/URLSearchParams/set
tags:
  - API
  - Method
  - URL API
  - URLSearchParams
  - set
---
<p>{{ApiRef("URL API")}}</p>

<p>The <strong><code>set()</code> </strong>method of the {{domxref("URLSearchParams")}} interface sets the value associated with a given search parameter to the given value. If there were several matching values, this method deletes the others. If the search parameter doesn't exist, this method creates it.</p>

<p>{{availableinworkers}}</p>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox notranslate">URLSearchParams.set(<em>name</em>, <em>value</em>)</pre>

<h3 id="Parameters">Parameters</h3>

<dl>
 <dt>name</dt>
 <dd>The name of the parameter to set.</dd>
 <dt>value </dt>
 <dd>The value of the parameter to set.</dd>
</dl>

<h3 id="Return_value">Return value</h3>

<p>Void.</p>

<h2 id="Examples">Examples</h2>

<p>Let's start with a simple example:</p>

<pre class="brush: js notranslate">let url = new URL('https://example.com?foo=1&amp;bar=2');
let params = new URLSearchParams(url.search);

//Add a third parameter.
params.set('baz', 3);
params.toString(); // <span class="message-body-wrapper"><span class="message-flex-body"><span class="devtools-monospace message-body"><span class="objectBox objectBox-string">"foo=1&amp;bar=2&amp;baz=3"</span></span></span></span>

</pre>

<p>Below is a real-life example demonstrating how to create a {{domxref("URL")}} and set some search parameters.</p>

<p>You can copy and paste the example in a code environment like Codepen, JSFiddle, or the <a href="/en-US/docs/Tools/Web_Console/The_command_line_interpreter">multi-line JavaScript interpreter in Firefox</a>.</p>

<ul>
 <li>line #41: Comment out this line to stop dumping the search parameters to the console (debug).</li>
 <li>line #43: Dumps the generated object and it's string representation to the console (info).</li>
 <li>line #44: Tries to automatically open a new window/tab with the generated URL (when uncommented).</li>
</ul>

<pre class="brush: js;highlight:[41,43,44] notranslate" id="genurl">'use strict'

function genURL(rExp, aText, bDebug=false){
	let theURL

	theURL= new URL('https://regexr.com')
	theURL.searchParams.set( 'expression', rExp.toString() )
	theURL.searchParams.set( 'tool', 'replace' )
	theURL.searchParams.set( 'input', '\u2911\u20dc' )// ⤑⃜
	theURL.searchParams.set( 'text', aText.join('\n') )
	if( bDebug ){
		// Display the key/value pairs
		for(var pair of theURL.searchParams.entries()) {
			console.debug(pair[0] + ' = \'' + pair[1] + '\'');
		}
		console.debug(theURL)
	}
	return theURL
}
var url = genURL(
	/(^\s*\/\/|\s*[^:]\/\/).*\s*$|\s*\/\*(.|\n)+?\*\/\s*$/gm	// single/multi-line comments
	// /(^\s*\/\/.*|\s*[^:]\/\/.*)/g								// single-line comments
	,[
		"These should work:",
		"",
		"// eslint-disable-next-line no-unused-vars",
		"lockPref(	'keyword.URL',\t\t'https://duckduckgo.com/html/?q=!+'	)\t//      test",
		"/*",
		"	* bla bla    ",
		"*/",
		"",
		"/* bla bla */",
		"",
		"// bla bla ",
		"",
		"These shouldn\'t work:",
		"console.log(\"http://foo.co.uk/\")",
		"var url = \"http://regexr.com/foo.html?q=bar\"",
		"alert(\"https://mediatemple.net\")",
	]
	, true
)
console.info( url, url.toString() )
// window.open( url, 'regex_site' )
</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{SpecName('URL', '#dom-urlsearchparams-set', "set()")}}</td>
   <td>{{Spec2('URL')}}</td>
   <td>Initial definition.</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<div>

<p>{{Compat("api.URLSearchParams.set")}}</p>
</div>
